﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;
using Infragistics.Web.UI;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        WebDataGrid1.DataSource = GetDS();
        TemplateDataField templateColumn1 = (TemplateDataField)WebDataGrid1.Columns["TemplateColumn1"];
        templateColumn1.ItemTemplate = new RestartItemTemplate();
    }

    protected override void OnInit(EventArgs e)
    {
        if (!IsPostBack)
        {
            TemplateDataField field1 = new TemplateDataField();
            field1.Key = "TemplateColumn1";
            field1.Header.Text = "Restart";
            this.WebDataGrid1.Columns.Add(field1);
        }
    }

    public DataTable GetDS()
    {
        System.Data.DataTable table = new DataTable("Table");
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "ID";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);

        // Create second column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table. 
        table.Columns.Add(column);

        // Create third column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);


        // Make the ID column the primary key column.
        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;



        for (int i = 0; i <= 20; i++)
        {
            row = table.NewRow();
            row["ID"] = i;
            row["Item"] = "Item " + i;
            row["Data"] = "Data " + i;
            table.Rows.Add(row);
        }
        return table;
    }

    protected void WebDataGrid1_ItemCommand(object sender, HandleCommandEventArgs e)
    {

    }
}

public class RestartItemTemplate : ITemplate
{
    public void InstantiateIn(Control container)
    {

        ImageButton btnRestart = new ImageButton();
        btnRestart.ImageUrl = "~/restart.gif";
        btnRestart.CommandName = "Restart";
        btnRestart.CommandArgument = ((DataRowView)((TemplateContainer)container).DataItem)["ID"].ToString();
        container.Controls.Add(btnRestart);

    }

}
